function createAccount() {
  if (!gSiteManager.length) {
    newSite();
  }
}

function newSite() {
  var params = { returnVal  : false,
                 localPath  : gLocalPath.value,
                 remotePath : gRemotePath.value,
                 site       : { account   : "",    host      : "", port     : 21,   login : "", password: "",
                                anonymous : false, security  : "", pasvmode : true,
                                localdir  : "",    remotedir : "", webhost  : "",   prefix: "", downloadcasemode: 0, uploadcasemode: 0 } };

  while (true) {                                                     // open up the Site Manager
    params.returnVal = false;
    window.openDialog("chrome://fireftp/content/accountManager.xul", "accountManager", "chrome,modal,dialog,resizable,centerscreen", params);

    if (!params.returnVal) {
      return;
    }

    var siteFound = false;                                           // make sure we don't have a duplicate
    for (var x = 0; x < gSiteManager.length; ++x) {
      if (gSiteManager[x].account == params.site.account) {
        siteFound = true;
        break;
      }
    }

    if (siteFound) {                                                 // we have a duplicate
      doAlert(gStrbundle.getString("dupAccount"), true);
      continue;
    } else {
      break;
    }
  }

  gSiteManager.push(params.site);

  accountHelper(params);
}

function editSite() {
  if (!gAccountField.value) {
    return;
  }

  var site;                                                          // grab a copy of the old site

  for (var x = 0; x < gSiteManager.length; ++x) {
    if (gSiteManager[x].account == gAccountField.value) {
      site = new cloneObject(gSiteManager[x]);
      break;
    }
  }

  var oldSite    = new cloneObject(site);
  site.temporary = false;
  var params     = { returnVal    : false,
                     localPath    : gLocalPath.value,
                     remotePath   : gRemotePath.value,
                     site         : site };

  while (true) {                                                     // open up the site manager
    params.returnVal = false;
    window.openDialog("chrome://fireftp/content/accountManager.xul", "accountManager", "chrome,modal,dialog,resizable,centerscreen", params);

    if (!params.returnVal) {
      return;
    }

    if (params.site.account != oldSite.account) {                    // make sure we don't have a duplicate account
      var siteFound = false;

      for (var x = 0; x < gSiteManager.length; ++x) {
        if (gSiteManager[x].account == params.site.account) {
          siteFound = true;
          break;
        }
      }

      if (siteFound) {                                               // we have a duplicate
        doAlert(gStrbundle.getString("dupAccount"), true);
        continue;
      }
    }                                                                // replace the old with the new

    for (var x = 0; x < gSiteManager.length; ++x) {
      if (gSiteManager[x].account == oldSite.account) {
        gSiteManager[x] = params.site;
        break;
      }
    }

    break;
  }

  try {                                                              // delete old password from list
    var recordedHost = (oldSite.host.indexOf("ftp.") == 0 ? '' : "ftp.") + oldSite.host;
    gPassManager.removeUser(recordedHost, oldSite.login);
  } catch (ex) { }

  accountHelper(params);
}

function deleteSite() {
  if (!gAccountField.value) {
    return;
  }

  if (!confirm(gStrbundle.getString("confirmDelete") + " '" + gAccountField.value + "'?")) {
    return;
  }

  for (var x = 0; x < gSiteManager.length; ++x) {                    // delete the account
    if (gSiteManager[x].account == gAccountField.value) {
      try {                                                          // delete password from list
        var recordedHost = (gSiteManager[x].host.indexOf("ftp.") == 0 ? '' : "ftp.") + gSiteManager[x].host;
        gPassManager.removeUser(recordedHost, gSiteManager[x].login);
      } catch (ex) { }

      gSiteManager.splice(x, 1);

      break;
    }
  }

  saveSiteManager();
  loadSiteManager();
}

function saveTempSite() {
  if (!gAccountField.value) {
    return;
  }

  var account = gAccountField.value;

  for (var x = 0; x < gSiteManager.length; ++x) {
    if (gSiteManager[x].account == gAccountField.value) {
      gSiteManager[x].temporary = false;
      break;
    }
  }

  saveSiteManager();
  loadSiteManager();

  for (var x = 0; x < gSiteManager.length; ++x) {                    // select the new site
    if (gSiteManager[x].account == account) {
      gAccountField.selectedIndex = x;
      onAccountChange();
      break;
    }
  }
}

function quickConnect() {                                            // make a quick connection, account not saved
  var params = { returnVal    : false,
                 quickConnect : true,
                 localPath    : gLocalPath.value,
                 remotePath   : gRemotePath.value,
                 site         : { account   : "",    host      : "", port     : 21,   login : "", password: "",
                                  anonymous : false, security  : "", pasvmode : true,
                                  localdir  : "",    remotedir : "", webhost  : "",   prefix: "", downloadcasemode: 0, uploadcasemode: 0,
                                  temporary : true } };

  window.openDialog("chrome://fireftp/content/accountManager.xul", "accountManager", "chrome,modal,dialog,resizable,centerscreen", params);

  if (!params.returnVal) {
    return;
  }

  tempAccountHelper(params);
}

function externalLink() {                                            // opened up fireFTP using a link in Firefox
  var params = { returnVal  : false,
                 localPath  : gLocalPath.value,
                 remotePath : gRemotePath.value,
                 site       : { account   : "",   host      : "", port     : 21,   login : "anonymous", password: "fireftp@example.com",
                                anonymous : true, security  : "", pasvmode : gTempPasvMode,
                                localdir  : "",   remotedir : "", webhost  : "",   prefix: "", downloadcasemode: 0, uploadcasemode: 0,
                                temporary : true } };

  var uri  = Components.classes["@mozilla.org/network/standard-url;1"].getService(Components.interfaces.nsIURI);
  uri.spec = gLoadUrl;

  if (!uri.schemeIs("ftp") || gLoadUrl.length <= 6) {                // sanity check
    return;
  }

  if (uri.username) {
    params.site.login     = unescape(uri.username);
    params.site.password  = unescape(uri.password);
    params.site.anonymous = params.site.login ? false : true;
  }

  params.site.host = uri.host;
  params.site.port = uri.port == -1 ? 21 : uri.port;

  var prefBranch   = gPrefsService.getBranch("browser.");
  gLoadUrl         = uri.path.charAt(uri.path.length - 1) == '/' ? "" : unescape(uri.path);

  try {
    if (prefBranch.getBoolPref("download.useDownloadDir")) {
      params.site.localdir  = prefBranch.getCharPref("download.dir");
    }
  } catch (ex) { }

  params.site.remotedir = gLoadUrl == "" ? unescape(uri.path) : unescape(uri.path.substring(0, uri.path.lastIndexOf('/')));

  gPrefs.setCharPref("loadurl", "");

  tempAccountHelper(params);
}

function accountHelper(params) {
  if (gPasswordMode) {
    var host     = { value : "" };
    var login    = { value : "" };
    var password = { value : "" };

    try {                                                            // save username & password
      var recordedHost  = (params.site.host.indexOf("ftp.") == 0 ? '' : "ftp.") + params.site.host;

      gPassManager.addUser(recordedHost, params.site.login, params.site.password);
    } catch (ex) {
      debug(ex);
    }
  }

  var tempPassword = params.site.password;
  saveSiteManager();                                                 // save site manager
  loadSiteManager();

  for (var x = 0; x < gSiteManager.length; ++x) {                    // select the new site
    if (gSiteManager[x].account == params.site.account) {
      gAccountField.selectedIndex = x;
      gSiteManager[x].password    = tempPassword;                    // if "Remember Passwords" is off we have to remember what it is temporarily
      onAccountChange();
      break;
    }
  }
}

function tempAccountHelper(params) {
  params.site.account = params.site.host;

  var found = true;
  var count = 0;

  while (found) {
    found = false;

    for (var x = 0; x < gSiteManager.length; ++x) {
      if (gSiteManager[x].account == params.site.account) {
        found = true;
        ++count;
        params.site.account = params.site.host + '-' + count.toString();
        break;
      }
    }
  }

  gSiteManager.push(params.site);

  accountHelper(params);

  connect(true);
}

function onAccountChange() {
  var accountToLoad = gFtp.isConnected ? gAccount : gAccountField.value;

  for (var x = 0; x < gSiteManager.length; ++x) {                    // load up the new values into the global variables
    if (gSiteManager[x].account == accountToLoad) {
      accountChangeHelper(gSiteManager[x]);
      break;
    }
  }

  if (gAccountField.value) {
    accountButtonsDisabler(false);
  }
}

function accountChangeHelper(site) {
  gFtp.host         = site.host;
  gFtp.port         = site.port;
  gFtp.security     = site.security;
  gFtp.login        = site.login;
  gFtp.password     = site.password;
  gFtp.passiveMode  = site.pasvmode;
  gAccount          = site.account;
  gDownloadCaseMode = site.downloadcasemode;
  gUploadCaseMode   = site.uploadcasemode;
  gWebHost          = site.webhost;
  gPrefix           = site.prefix;

  if (!gFtp.isConnected) {
    if (site.localdir) {
      var dir = localFile.init(site.localdir);
      if (localFile.verifyExists(dir)) {
        localDirTree.changeDir(site.localdir); 
      } else {
        error(gStrbundle.getString("noPermission"));
      }
    }

    if (site.remotedir) {
      gRemotePath.value = site.remotedir;
    } else {
      gRemotePath.value = "/";
    }
  }

  gFtp.initialPath  = gRemotePath.value;

  accountButtonsDisabler(false);
}

function setConnectButton(connect) {
  gConnectButton.label =                   connect ? gStrbundle.getString("connectButton") : gStrbundle.getString("disconnectButton");
  gConnectButton.setAttribute('command',   connect ? 'cmd_connect'                         : 'cmd_disconnect');
  gConnectButton.setAttribute('accesskey', connect ? gStrbundle.getString("connectAccess") : gStrbundle.getString("disconnectAccess"));
}

function accountButtonsDisabler(enable) {
  $('editMenuItem').setAttribute(  "disabled", enable);
  $('deleteMenuItem').setAttribute("disabled", enable);

  if (!gFtp.isConnected) {
    $('connectbutton').disabled = enable;
  }

  if (gSiteManager) {
    for (var x = 0; x < gSiteManager.length; ++x) {
      if (gSiteManager[x].account == gAccountField.value) {
        $('saveMenuItem').setAttribute("disabled", !gSiteManager[x].temporary);
        break;
      }
    }
  } else {
    $('saveMenuItem').setAttribute("disabled", true);
  }
}

function connectedButtonsDisabler() {
  $('abortbutton').disabled =                  !gFtp.isConnected;
  $('customMenuItem').setAttribute("disabled", !gFtp.isConnected);
  $('diffMenuItem').setAttribute(  "disabled", !gFtp.isConnected);
}

function loadSiteManager(pruneTemp, importFile) {
  // read gSiteManager data
  try {
    gAccountField.removeAllItems();

    if (!gFtp.isConnected) {
      gFtp.host         = "";
      gFtp.port         = 21;
      gFtp.security     = "";
      gFtp.login        = "";
      gFtp.password     = "";
      gFtp.passiveMode  = true;
      gFtp.initialPath  = "";
      gAccount          = "";
      gDownloadCaseMode = 0;
      gUploadCaseMode   = 0;
      gWebHost          = "";
      gPrefix           = "";
      gRemotePath.value = "/";
    }

    var file = importFile ? importFile : localFile.init(gProfileDir.path + gSlash + "fireFTPsites.dat");

    if (!file.exists() && !importFile) {
      gSiteManager = new Array();
    } else if (file.exists()) {
      var fstream  = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
      var sstream  = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
      fstream.init(file, 1, 0, false);
      sstream.init(fstream);

      var siteData = "";
      var str      = sstream.read(-1);

      while (str.length > 0) {
        siteData += str;
        str       = sstream.read(-1);
      }

      if (importFile) {
        var tempSiteManager = eval(siteData);

        for (var x = 0; x < tempSiteManager.length; ++x) {
          var found   = true;
          var count   = 0;
          var skip    = true;
          var account = tempSiteManager[x].account;

          while (found) {
            found = false;

            for (var y = 0; y < gSiteManager.length; ++y) {
              if (gSiteManager[y].account == account) {
                found = true;

                for (i in gSiteManager[y]) {                         // if it's the exact same object skip it
                  if (gSiteManager[y][i] != tempSiteManager[x][i]) {
                    skip = false;
                  }
                }

                if (skip) {
                  break;
                }

                ++count;
                account = tempSiteManager[x].account + '-' + count.toString();
                break;
              }
            }

            if (skip) {
              break;
            }
          }

          if (skip) {
            continue;
          }

          tempSiteManager[x].account = account;
          gSiteManager.push(tempSiteManager[x]);
        }
      } else {
        gSiteManager = eval(siteData);
      }

      if (gPasswordMode) {
        for (var x = 0; x < gSiteManager.length; ++x) {              // retrieve passwords from passwordmanager
          try {
            var host = { value : "" };    var login = { value : "" };    var password = { value : "" };
            gPassManagerIn.findPasswordEntry((gSiteManager[x].host.indexOf("ftp.") == 0 ? '' : "ftp.")
                                            + gSiteManager[x].host, gSiteManager[x].login, "", host, login, password);

            gSiteManager[x].password = password.value;
          } catch (ex) { }
        }
      }

      sstream.close();
      fstream.close();

      if (pruneTemp) {
        for (var x = gSiteManager.length - 1; x >= 0; --x) {
          if (gSiteManager[x].temporary) {
            gSiteManager.splice(x, 1);
          }
        }
      }

      for (var x = 0; x < gSiteManager.length; ++x) {
        gAccountField.appendItem(gSiteManager[x].account, gSiteManager[x].account);
      }
    }

    if (gSiteManager.length) {
      gAccountField.setAttribute("label", gStrbundle.getString("chooseAccount"));
    } else {
      gAccountField.setAttribute("label", gStrbundle.getString("noAccounts"));
    }

    accountButtonsDisabler(true);
  } catch (ex) {
    debug(ex);
  }
}

function saveSiteManager(exportFile) {
  try {                                                              // write gSiteManager out to disk
    var tempSiteManagerArray = new Array();

    for (var x = 0; x < gSiteManager.length; ++x) {
      tempSiteManagerArray.push(new cloneObject(gSiteManager[x]));
    }

    for (var x = 0; x < tempSiteManagerArray.length; ++x) {          // we don't save out the passwords, those are saved in the passwordmanager
      tempSiteManagerArray[x].password = "";
    }

    var file = exportFile ? exportFile : localFile.init(gProfileDir.path + gSlash + "fireFTPsites.dat");
    var foutstream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
    foutstream.init(file, 0x04 | 0x08 | 0x20, 0644, 0);
    tempSiteManagerArray.sort(compareAccount);
    foutstream.write(tempSiteManagerArray.toSource(), tempSiteManagerArray.toSource().length);
    foutstream.close();
  } catch (ex) {
    debug(ex);
  }
}

function importSites() {
  var nsIFilePicker   = Components.interfaces.nsIFilePicker;
  var fp              = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  fp.defaultExtension = "dat";
  fp.appendFilter("FireFTP", "*.dat");
  fp.init(window, null, nsIFilePicker.modeOpen);
  var res = fp.show();

  if (res != nsIFilePicker.returnOK) {
    return;
  }

  var tempAccount = gAccountField.value;

  loadSiteManager(true, fp.file);
  saveSiteManager();                                                 // save site manager
  loadSiteManager();

  for (var x = 0; x < gSiteManager.length; ++x) {                    // select the new site
    if (gSiteManager[x].account == tempAccount) {
      gAccountField.selectedIndex = x;
      onAccountChange();
      break;
    }
  }
}

function exportSites() {
  var nsIFilePicker   = Components.interfaces.nsIFilePicker;
  var fp              = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  fp.defaultString    = "fireFTPsites.dat";
  fp.defaultExtension = "dat";
  fp.appendFilter("FireFTP", "*.dat");
  fp.init(window, null, nsIFilePicker.modeSave);
  var res = fp.show();

  if (res == nsIFilePicker.returnOK) {
    saveSiteManager(fp.file);
  }
}
